<template lang="pug">
title-bar {{ brand ? brand.name : "..." }}
b-container( v-if='brand && meta' )
	.tile.is-ancestor
		.tile.is-parent
			b-card.tile.is-child: brand-form( :brand='brand' :meta='meta' @submit='editBrand' edit )
</template>

<script setup>
	import BrandForm from "@/components/brand/Form.vue"

	import { computed, onMounted, ref, watch } from "vue"

	import { useRoute } from "vue-router"
	import { useBrandStore } from "@/stores/brand"
	import { useI18n } from "vue-i18n"
	import { useToast } from "vue-toastification"

	const { t } = useI18n()
	const toast = useToast()
	const $route = useRoute()
	const bs = useBrandStore()

	const brand = ref(null)
	const meta = ref(null)

	const id = computed(() => $route.params.id)

	const fetch = async () => {
		if (id.value) {
			const data = await bs.getBrand(id.value)
			brand.value = data.brand
			meta.value = data.meta
		}
	}

	const editBrand = async body => {
		try {
			await bs.editBrand(id.value, body)
			toast.success(t("default.changes_saved"))
		} catch(err) { console.error(err) }
	}

	watch(() => id.value, fetch)
	onMounted(fetch)
</script>

<style lang="scss"></style>